/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.jtests.clients.entity;

import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.objectweb.jonas.jtests.beans.annuaire.PersonneHome;

/**
 * Test the TimerService on entity beans
 * Beans used: annuaire
 * @author Philippe Durieux (jonas team)
 */
public class F_TimerEC2 extends A_Timer {

    private static String BEAN_HOME = "annuairePersonneEC2Home";
    private static PersonneHome ehome = null;

    public F_TimerEC2(String name) {
        super(name);
    }
  
    public PersonneHome getHome() {
        if (ehome == null) {
            try {
                ehome = (PersonneHome) PortableRemoteObject.narrow(ictx.lookup(BEAN_HOME), PersonneHome.class);
            } catch (NamingException e) {
                fail("Cannot get bean home");
            }
            // init here tables if CMP2
            try {
                ehome.create("Philippe Coq", "1235456");
                ehome.create("Philippe Durieux", "638");
                ehome.create("Adriana Danes", "1233456");
                ehome.create("Helene Joanin", "1230456");
                ehome.create("Gerard Vandome", "1232456");
                ehome.create("Francois Exertier", "1323456");
                ehome.create("Emmanuel Facarde", "1234356");
                ehome.create("Charly Mingus", "1238456");
                ehome.create("Thelonious Monk", "1239456");
                ehome.create("Jean-Luc Richard", "1203456");
            } catch (Exception i) {
                // Tables are already created. Ignore exception.
            }
        }
        return ehome;
    }

    public static Test suite() {
        return new TestSuite(F_TimerEC2.class);
    }

    public static void main (String args[]) {
        String testtorun = null;
        // Get args
        for (int argn = 0; argn < args.length; argn++) {
            String s_arg = args[argn];
            Integer i_arg;
            if (s_arg.equals("-n")) {
                testtorun = args[++argn];
            }
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else {
            junit.textui.TestRunner.run(new F_TimerEC2(testtorun));
        }
    }
}
